#property script_show_inputs

#include <fxsaber\SingleTesterCache\SingleTesterCache.mqh> // https://www.mql5.com/ru/code/27611
#include <fxsaber\MultiTester\MTTester.mqh> // https://www.mql5.com/ru/code/26132

input double inCommission = 20; //   ( )
input double inCommissionPAMM = 25; // - ( )
input datetime inStartTime = D'2021.01.01'; //    

input double inCommissionPart = 75; //   ( )   
input double inFee = 30; //   (  > 0)    

double GetProfit( const SINGLETESTERCACHE &SingleTesterCache, const double Commission, int &Deals, const datetime StartTime = 0 )
{
  double Profit = 0;

  Deals = 0;

  for (uint i = 0; i < SingleTesterCache.Header.deals_total; i++)
    if ((SingleTesterCache.Deals[i].action <= DEAL_TYPE_SELL) && (SingleTesterCache.Deals[i].time_create > StartTime))
    {
      Profit += SingleTesterCache.Deals[i].profit -
                SingleTesterCache.Deals[i].price_open * Commission / (1e6 * SymbolInfoDouble(SingleTesterCache.Deals[i].symbol[], SYMBOL_POINT));

      Deals++;
    }

  Deals >>= 1;

  return(Profit);
}

void OnStart()
{
  const double Fee = inFee / 100;
  const double Koef = inCommissionPart / 100;

  const double MeanMax = Fee ? (1 - Koef * (1 - Fee)) / Fee : 0;

  const string StrDiscount = "   " + (string)inCommissionPart + "%\n" +
                             " " + (string)inFee + "% \n\n" +
                             "  ,  .     :\n" +
                             "Commission * " + DoubleToString(Koef, 2) + " < Mean < " + DoubleToString(MeanMax, 2) + " * Commission";

  uchar Bytes2[];

  if (MTTESTER::GetLastTstCache(Bytes2) != -1) //     -  
  {
    const SINGLETESTERCACHE SingleTesterCache(Bytes2);

    int Deals;

    const string Symb = SingleTesterCache.Summary.symbol[];
    const double Profit = GetProfit(SingleTesterCache, 0, Deals, inStartTime);

    MqlTick Ticks[1];

    CopyTicks(Symb, Ticks, COPY_TICKS_INFO, 0, 1);
    const double point = SymbolInfoDouble(Symb, SYMBOL_POINT);

    const double Commission = Ticks[0].ask * 2 * inCommission / (1e6 * SymbolInfoDouble(Symb, SYMBOL_POINT));

    const double Profit1 = GetProfit(SingleTesterCache, inCommission, Deals, inStartTime);
    const double ProfitPAMM = GetProfit(SingleTesterCache, inCommissionPAMM, Deals, inStartTime);
    const double Profit2 = GetProfit(SingleTesterCache, inCommission * Koef, Deals, inStartTime) * (1 - Fee);

  #define TOSTRING(A) #A + " = " + (string)(A) + "\n"

    string Str = TOSTRING(Symb) + TOSTRING(inStartTime) +
                 TOSTRING(Profit) + TOSTRING(Deals) + TOSTRING(Profit / Deals) +
                 "(" + DoubleToString(Profit / (Deals * Commission), 2) + " * Commission)\n\n" +
                 TOSTRING(Commission) + TOSTRING(inCommission) + TOSTRING(inCommissionPAMM)
                 "\n    = " + DoubleToString(Profit1, 2) +
                 " (" + DoubleToString(Profit1 / Profit * 100, 2) + "%  )" +

                 "\n\n    = " + DoubleToString(Profit2, 2) +
                 " (" + DoubleToString(Profit2 / Profit1 * 100, 2) + "%  )" +

                 "\n\n  - = " + DoubleToString(ProfitPAMM, 2) +
                 " (" + DoubleToString(ProfitPAMM / Profit1 * 100, 2) + "%  )";

    MessageBox(Str + "\n\n" + StrDiscount);
  }
}